#include <iostream.h>
#include <fstream.h>
#include <string.h>

// NESID: displays header info about iNES-formatted NES ROMs

int main(int argc,char **argv) {
   unsigned int mappy=0;
   char noname[] = "unknown";
   char *mapnames[36] = {"NROM","MMC1","UNROM","CNROM",
                          "MMC3","MMC5","FFE F4xxx","AOROM",
                          "FFE F3xxx","MMC2","MMC4","Color Dreams",
                          noname,noname,noname,"100-in-1",
                          "Bandai","FFE F8xxx","Jaleco SS8806","Namcot 106",
                          noname,"Konami VRC4","Konami VRC2 type A","Konami VRC2 type B",
                          noname,noname,noname,noname,
                          noname,noname,noname,noname,
                          "Irem G-101","Taito TC0190","Nina-1",noname};
   if (argc==1) {cout << "NESID v2\n(c) 2003 Halley's Comet Software (http://here.is/halleyscomet)\nMapper names from \\Firebug\\'s doc\n\nDisplays header info about iNES format NES ROMs\n"; return 0;}

   ifstream infile(argv[1],iostream::binary);
   if (!infile) {
      char *newname = new char [strlen(argv[1])+5];
      int c;
      for (c=0;c<strlen(argv[1]);c++) newname[c]=argv[1][c];
      newname[c]='.'; newname[c+1]='n'; newname[c+2]='e'; newname[c+3]='s';
      newname[c+4]='\0';
      infile.open(newname,iostream::binary);
      if (!infile) {
         cout << "Error opening " << argv[1] << '\n';
         return 0;
      } else cout << newname << ":\n";
   } else cout << argv[1] << ":\n";
   unsigned char header[16];
   infile.read(header,16);
   if (header[0]=='N'&&header[1]=='E'&&header[2]=='S'&&header[3]==0x1A) {
      cout << "16K PRG-ROM Page Count: " << (unsigned int)header[4] << '=' << header[4]*0x4000 << " bytes\n";
      cout << "8K  CHR-ROM Page Count: " << (unsigned int)header[5] << '=' << header[5]*0x2000 << " bytes\n";
      if (header[6]&0x08) {
         cout << "4-screen mirroring\n";
      } else {
         if (header[6]&0x01) {
            cout << "Vertical mirroring\n";
         } else {
            cout << "Horizontal mirroring\n";
         }
      }
      if (header[6]&2) cout << "SRAM Enabled\n";
      if (header[6]&4) cout << "Trainer present\n";
      cout << "Mapper " << (mappy=(((unsigned int)header[6]&0xf0)>>4)) << " (" << (header[7]&0xf0|((header[6]&0xf0)>>4)) << "): ";
      if (mappy < 35) cout << mapnames[mappy];
      else cout << noname;
   } else {cout << "Not an iNES ROM!";}

   cout << '\n';

   infile.close();

   return mappy;
}
